%global momorel 10

%define rcver rc21
%define webroot /var/www/boa

Summary: Single-tasking HTTP server
Name: boa
Version: 0.94.14
Release: 0.6.%{momorel}m%{?dist}
URL: http://www.boa.org/
License: GPLv2+
Group: System Environment/Daemons
Source0: http://www.boa.org/boa-%{version}%{?rcver}.tar.bz2
Source1: boa.init
Source2: boa.sysconfig
Source10: index.html
Source11: boa_logo_pasi2.png
Source12: powered_by_momonga.png
Patch0: boa-0.94.14rc21-config.patch
Patch1: boa-0.94.14rc21-cgi.c.patch
Patch2: boa-0.94.14rc21-escape-errorlog.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(pre): shadow-utils
Requires(post): initscripts chkconfig
Requires(postun): chkconfig
Requires: gzip
Requires: mailcap
BuildRequires: tetex, texinfo
Provides: webserver

%description
Boa is a single-tasking HTTP server. That means that unlike traditional web
servers, it does not fork for each incoming connection, nor does it fork many
copies of itself to handle multiple connections. It internally multiplexes
all of the ongoing HTTP connections, and forks only for CGI programs (which
must be separate processes), automatic directory generation, and automatic
file gunzipping.
The primary design goals of Boa are speed and security. Security, in the sense
of "can't be subverted by a malicious user," not "fine grained access control
and encrypted communications". Boa is not intended as a feature-packed server.

Available rpmbuild rebuild options :
--with : debug access poll
--without : gunzip sendfile


%prep
%setup -q -n %{name}-%{version}%{?rcver}
%patch0 -p1 -b .config
%patch1 -p1 -b .cgi.c
%patch2 -p1 -b .escape-errorlog


%build
%configure \
    %{!?_with_debug:      --disable-debug} \
    %{?_with_access:      --enable-access-control} \
    %{?_with_poll:        --with-poll} \
    %{?_without_gunzip:   --disable-gunzip} \
    %{?_without_sendfile: --disable-sendfile}
%{__make} %{?_smp_mflags}
%{__make} -C docs boa.html boa.txt


%install
%{__rm} -rf %{buildroot}
# Manual install is still mandatory
%{__install} -p -m 0755 -D src/boa \
    %{buildroot}%{_sbindir}/boa
%{__install} -p -m 0755 -D src/boa_indexer \
    %{buildroot}%{_libexecdir}/boa/boa_indexer
%{__install} -p -m 0644 -D docs/boa.8 \
    %{buildroot}%{_mandir}/man8/boa.8
%{__install} -p -m 0644 -D examples/boa.conf \
    %{buildroot}%{_sysconfdir}/boa/boa.conf
%{__install} -p -m 0644 -D contrib/rpm/boa.logrotate \
    %{buildroot}%{_sysconfdir}/logrotate.d/boa
%{__install} -p -m 0755 -D %{SOURCE1} \
    %{buildroot}%{_initscriptdir}/boa
%{__install} -p -m 0755 -D %{SOURCE2} \
    %{buildroot}%{_sysconfdir}/sysconfig/boa

%{__mkdir_p} %{buildroot}/%{webroot}/{cgi-bin,html}
%{__mkdir_p} %{buildroot}/%{_var}/log/boa

# Install the default index.html file
%{__install} -p -m 0644 %{SOURCE10} %{SOURCE11} %{SOURCE12} \
    %{buildroot}%{webroot}/html/

# Avoid automatic picking up of perl dependency
%{__chmod} -x examples/*.{cgi,pl}


%clean
%{__rm} -rf %{buildroot}


%pre
/usr/sbin/groupadd -r www 2>/dev/null || :
/usr/sbin/useradd -s /bin/false -c "Web server user" \
    -d %{webroot} -M -r -g www boa 2>/dev/null || :

%post
if [ $1 -eq 1 ]; then
    /sbin/chkconfig --add boa
fi

%preun
if [ $1 -eq 0 ]; then
    /sbin/service boa stop &>/dev/null || :
    /sbin/chkconfig --del boa
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service boa condrestart &>/dev/null || :
fi


%files
%defattr(-,root,root,-)
%doc COPYING CREDITS README
%doc docs/*.{html,png,txt} examples/
%dir %{_sysconfdir}/boa/
%config(noreplace) %{_sysconfdir}/boa/boa.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/boa
%config(noreplace) %{_sysconfdir}/sysconfig/boa
%{_initscriptdir}/boa
%dir %{_libexecdir}/boa/
%{_libexecdir}/boa/boa_indexer
%{_sbindir}/boa
%{webroot}/
%dir %{_var}/log/boa/
%{_mandir}/man8/*


%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.94.14-0.6.10m)
- full rebuild for mo7 release

* Tue May 25 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.94.14-0.6.9m)
- [SECURITY] CVE-2009-4496
- sync with Fedora 13 (0.94.14-0.15.rc21) and momonganize

* Sat Apr 24 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94.14-0.5.rc21.8m)
- use Requires

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.94.14-0.5.rc21.7m)
- rebuild against gcc-4.4 and glibc-2.11

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.94.14-0.5.rc21.6m)
- rebuild against rpm-4.6

* Fri Dec 26 2008 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.94.14-0.5.rc21.5m)
- revise for rpm46 (s/Patch/Patch0/ and s/%%patch/%%patch0/)
- License: GPLv2+

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94.14-0.5.rc21.4m)
- rebuild against gcc43

* Wed Jul 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.94.14-0.5.rc21.3m)
- PreReq: chkconfig, initscripts

* Mon Jul 23 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.94.14-0.5.rc21.2m)
- move start up script from %%{_initrddir} to %%{_initscriptdir}

* Sat Jul  7 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94.14-0.5.rc21.1m)
- import from f7 to Momonga

* Mon Aug 28 2006 Matthias Saou <http://freshrpms.net/> 0.94.14-0.5.rc21
- FC6 rebuild, remove gzip build requirement (it's a default).

* Mon Mar  6 2006 Matthias Saou <http://freshrpms.net/> 0.94.14-0.4.rc21
- FC5 rebuild.

* Wed Feb  8 2006 Matthias Saou <http://freshrpms.net/> 0.94.14-0.3.rc21
- Rebuild for new gcc/glibc.

* Wed Nov 16 2005 Matthias Saou <http://freshrpms.net/> 0.94.14-0.2.rc21
- Make example cgi scripts -x to avoid perl dependency side-effect (#173335).

* Sat Apr 16 2005 Seth Vidal <skvidal at phy.duke.edu> 0.94.14-0.1.rc21
- tar.gz not tar.bz2

* Thu Apr 14 2005 Matthias Saou <http://freshrpms.net/> 0.94.14-0.1.rc21
- Update to 0.94.14rc21.
- Change release tag "order" to comply with guidelines (extra info at the end).
- Change _initrddir (which I still see as plain wrong) to /etc/rc.d/init.d.
- Replace freshrpms logo with fedora one.
- Change flashy green from the default index.html to plain white.
- Minor spec file cosmetic changes.

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net> 0.94.14-0.rc17.3
- rebuilt

* Mon Feb 14 2005 Ville Skytta <ville.skytta at iki.fi> - 0.94.14-0.rc17.2
- Build only installed docs, avoids build failure with boa.dvi.
- Drop .fr release suffix.

* Wed Oct 22 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Initial package.

